HDU-2955Robberies

Robberies

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)


Description
The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.


For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.


His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.
 

 

Input
The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj . 
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .
 

 

Output
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.
 

 

Sample Input
3
0.04 3
1 0.02
2 0.03
3 0.05
 
0.06 3
2 0.03
2 0.03
3 0.05
 
0.10 3
1 0.03
2 0.02
3 0.05
 
Sample Output
2
4
6
总结
虽然想到是01背包问题,但还是不知道应该怎么建立状态转移方程,看了网上的解题思路,自己写了下,发现自己的总会TLE,别人的AC,最后发现自己数据初始化位置放错了,傻逼。
#include<iostream>
#include<cstdio>
using namespace std;
int m[105];
double dp[10010],v[105];

int main()
{
    int t,n,sum,i,j;
    double p;
    cin>>t;
    while(t--){
        scanf("%lf %d",&p,&n);
        sum=0;
        p=1-p;
        for(i=0;i<n;i++){
            scanf("%d %lf",&m[i],&v[i]);
            sum+=m[i];
            v[i]=1-v[i];
        }
        for(i=0;i<=sum;i++) dp[i]=0;
        dp[0]=1;
        for(i=0;i<n;i++){
            for(j=sum;j>=m[i];j--){
                dp[j]=max(dp[j],dp[j-m[i]]*v[i]);
            }
        }
        for(i=sum;i>=0;i--){
            if(dp[i]>p){
                printf("%d
",i);
                break;
            }
        }
    }
    return 0;
}
原文地址:https://www.cnblogs.com/wangdongkai/p/5357624.html